//+------------------------------------------------------------------+
//|                                            20PipsExpert_v1.2.mq4 |
//|                                  Copyright  2006, Forex-TSD.com |
//|                         Written by IgorAD,igorad2003@yahoo.co.uk |   
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |                                      
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Forex-TSD.com "
#property link      "http://www.forex-tsd.com/"

#include <stdlib.mqh>
//#include <Tracert.mqh>

//---- input parameters
extern string     Expert_Name = "---- 20PipsExpert_v1 ----";

extern int        Magic            = 10000;
extern int        Slippage         = 6;

extern string     Main_Parameters = " Trade Volume & Trade Method";
extern double     Lots             = 0.1;   // Lot size
extern int        TradeMode        =   0;   // 0 - Stop Orders; 1 - Limit Orders

extern string     Data = " Input Data "; 
extern int        StartTime        = 20;    // Time for Orders Open 
extern int        MinuteforOpen    =  5;    // Lag for Orders Open
extern int        FridayTrade      =  0;    // Trade at Friday switch 
extern double     InitialStop      = 50;    // Initial Stop in pips 
extern double     TakeProfit       = 20;    // Profit Lock in pips  
extern double     PendOrdGap       = 25;    // Gap for Pending Orders from Open in pips
extern int        DaysBack         =  1;    // Days Back for Evaluation


extern string     MM_Parameters = " MoneyManagement by L.Williams ";
extern bool       MM=false;                 //  Switch
extern double     MMRisk=0.15;              // Risk Factor
extern double     LossMax=1000;             // Maximum Loss by 1 Lot


int      i=0, cnt=0, ticket, mode=0, digit=0, numords, PeriodName ;
double   PrevPrice=0, Price=0, SellProfit=0,BuyProfit=0;
double   BuyStop=0, SellStop=0, Lotsi=0, BuyPrice=0, SellPrice = 0;
bool     BuyInTrade=false, SellInTrade=false, FirstTime = false;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//---- 
   FirstTime = true;
//----
   return(0);
  }
  
// ---- Money Management
double MoneyManagement ( bool flag, double Lots, double risk, double maxloss)
{
   Lotsi=Lots;
	    
   if ( flag ) Lotsi=NormalizeDouble(Lots*AccountFreeMargin()*risk/maxloss,1);   
     
   if (Lotsi<0.1) Lotsi=0.1;  
   return(Lotsi);
}   

// ---- Open Sell Orders
void SellOrdOpen()
{		     
        if (TradeMode == 0) int OrdMode = OP_SELLSTOP; else OrdMode = OP_SELLLIMIT; 
		  
		  if (InitialStop   > 0) SellStop=SellPrice + InitialStop*Point; else SellStop=0;
        if (TakeProfit > 0)    SellProfit=SellPrice - TakeProfit*Point; else SellProfit=0; 
		
		  ticket = OrderSend( Symbol(),OrdMode,Lotsi,
		                      NormalizeDouble(SellPrice, digit),
		                      Slippage,
		                      NormalizeDouble(SellStop , digit),
		                      NormalizeDouble(SellProfit   , digit),
		                      "sell",Magic,0,Red);
            
        SellInTrade=false;        
            
            if(ticket<0)
            {
            Print("SELLSTOP: OrderSend failed with error #",GetLastError());
            //
            }
}
// ---- Open Buy Orders
void BuyOrdOpen()
{		     

		  if (TradeMode == 0) int OrdMode = OP_BUYSTOP; else OrdMode = OP_BUYLIMIT; 
		  
		  if (InitialStop > 0) BuyStop = BuyPrice - InitialStop*Point; else BuyStop=0;
        if (TakeProfit>0) BuyProfit=BuyPrice + TakeProfit*Point; else BuyProfit=0;  
		 
		  ticket = OrderSend(Symbol(),OrdMode, Lotsi,
		                     NormalizeDouble(BuyPrice, digit),
		                     Slippage,
		                     NormalizeDouble(BuyStop , digit), 
		                     NormalizeDouble(BuyProfit  , digit),
		                     "buy",Magic,0,Blue);
                
        BuyInTrade=false;             
            
            if(ticket<0)
            {
            Print("BUYSTOP: OrderSend failed with error #",GetLastError());
            //return(0);
            }
}      

// ---- Scan Trades
int ScanTrades()
{   
   int total = OrdersTotal();
   int numords = 0;
      
   for(cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()>=OP_BUY && OrderMagicNumber() == Magic) 
   numords++;
   }
   return(numords);
}

// Closing of Pending Orders      
void PendOrdDel()
{
    int total=OrdersTotal();
    for (int cnt=total-1;cnt>=0;cnt--)
    { 
      OrderSelect(cnt, SELECT_BY_POS,MODE_TRADES);   
      
        if ( OrderSymbol()==Symbol() && OrderMagicNumber()==Magic  )     
        {
        int mode=OrderType();
        
        bool result = false;
          switch(mode)
          {
            
            case OP_BUYSTOP   : result = OrderDelete( OrderTicket() ); 
          
            case OP_SELLSTOP  : result = OrderDelete( OrderTicket() ); 
          if(!result)
            {
            Print("OrderSend failed with error #",GetLastError());
            return(0);
            }
          //Print(" cnt=",cnt, " total=",total," MODE = ",mode," Ticket=",OrderTicket()  );                       
          }
         }
      } 
  return;
  }
  
datetime OrderOpenDate()
{
   int total = OrdersTotal();
   datetime date;
   for(cnt=0; cnt<total; cnt++) 
   {        
   OrderSelect(cnt, SELECT_BY_POS);            
   if(OrderSymbol() == Symbol() && OrderType()>=OP_BUY && OrderMagicNumber() == Magic) 
   date = StrToTime(TimeToStr(OrderOpenTime(),TIME_DATE));
   }
   return(date);
}        
         	                    
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//---- 
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
   if(Bars < 1) {Print("Not enough bars for this strategy");return(0);}
   
      
   digit  = MarketInfo(Symbol(),MODE_DIGITS);
    
   if (Hour()>=StartTime && Hour()< StartTime+1 && Minute()<= MinuteforOpen ) 
   {  
   
   if ( OrdersTotal()>0 && OrderOpenDate() != StrToTime(TimeToStr( CurTime(),TIME_DATE))) PendOrdDel();   
   
      if ( FirstTime )
      {
      if (DayOfWeek()!= 1) 
      PrevPrice = iClose(Symbol(),PERIOD_H1,1+DaysBack*24);
      else
      PrevPrice = iClose(Symbol(),PERIOD_H1,DaysBack*24);
      //Print(" Prev=",PrevPrice);
      double BuyLevel = PrevPrice + PendOrdGap*Point;
      double SellLevel = PrevPrice  - PendOrdGap*Point;
      FirstTime = false;
      }
      
   Price = iClose(NULL,PERIOD_H1,1);
   if ( Price > BuyLevel  ) double Delta = ( Price -  BuyLevel )/Point;
   if ( Price < SellLevel ) Delta = ( SellLevel - Price )/Point;
   if ( Price < BuyLevel && Price > SellLevel ) Delta = 0;
   //Print(" Buy=",BuyPrice," Sell=",SellPrice," Delta=",Delta);
   bool BuyCondition  = ( Delta > 5 && Price < SellLevel );
   bool SellCondition = ( Delta > 5 && Price > BuyLevel  );
   
   Lotsi = MoneyManagement ( MM, Lots, MMRisk, LossMax);
   BuyLevel =Price + PendOrdGap*Point;
   SellLevel=Price - PendOrdGap*Point; 
   
   if ( TradeMode == 0)
   {
   BuyPrice =BuyLevel;
   SellPrice=SellLevel;  
   }
   else
   {
   BuyPrice =Price - PendOrdGap*Point;
   SellPrice=Price + PendOrdGap*Point;  
   }
      if(ScanTrades() < 1)
      {
         if (FridayTrade == 0)
         {
            if ( SellCondition && DayOfWeek()!=5) SellOrdOpen();
            if ( BuyCondition  && DayOfWeek()!=5) BuyOrdOpen();
         }
         else
         {
            if ( SellCondition) SellOrdOpen();
            if ( BuyCondition ) BuyOrdOpen();   
         }
      }
   }
   
   
 return(0);
}//int start
//+------------------------------------------------------------------+





